/****************************************************************************
*
*  $RCSfile: testusage.c,v $
*
*   Scratch test of iconv functionality
*  Original Author: Caskey Dickson <caskey@technocage.com> 2001-02-22
*  Copyright 2001 TechnoCage, Inc.  All Rights Reserved
*  $Id: testusage.c,v 1.1 2001/02/22 22:35:49 caskey Exp $
*
*   This program is free software; you can redistribute it and/or
*   modify it under the terms of the GNU General Public License
*   as published by the Free Software Foundation; either version 2
*   of the License, or (at your option) any later version.
*
*   This program is distributed in the hope that it will be useful,
*   but WITHOUT ANY WARRANTY; without even the implied warranty of
*   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*   GNU General Public License for more details.
*
*   You should have received a copy of the GNU General Public License
*   along with this program; if not, write to the Free Software Foundation, 
*   Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*
*****************************************************************************/

#include <iconv.h>
#include <stdio.h>

int main(int argc, char* argv[]) {
  iconv_t ic;
  size_t charsConverted = 0;
  size_t fooLength = 13;
  size_t barLength = 20;
  char foo[] = "hello world!";
  char bar[barLength];
  char *barPtr = bar;
  char *fooPtr = foo;

  foo[5] = 200;
  memset(bar, 0, barLength);
  fprintf(stderr, "siconv\n");

  printf("foo:%s\n", foo);
  printf("bar:%s\n", bar);

  printf("cc:%d, ic:%08x, foo:%s, fLen:%d, bar:%s, bLen:%d\n", 
      charsConverted, (unsigned int)ic, foo, fooLength, bar, barLength);
  fprintf(stderr, "converting... ");
  ic = iconv_open("utf8", "iso-8859-1");

  // initialize ic
  charsConverted = iconv(ic, 0, 0, 0, 0);

  charsConverted = iconv(ic, (const char**)&fooPtr, &fooLength, &barPtr, &barLength);
  // ignoring potential error code because we don't care at this point
  iconv_close(ic);
  fprintf(stderr, "OK\n");
  printf("cc:%d, ic:%08x, foo:%s, fLen:%d, bar:%s, bLen:%d\n", 
      charsConverted, (unsigned int)ic, foo, fooLength, bar, barLength);

  printf("foo:%s\n", foo);
  printf("bar:%s\n", bar);
  return 0;
}
